export type ChainOptions = {
    withoutLinkResolution?: boolean;
    withAllLocales?: boolean;
    withoutUnresolvableLinks?: boolean;
};
export interface ChainOptionWithoutLinkResolution extends ChainOptions {
    withoutLinkResolution: true;
}
export interface ChainOptionWithLinkResolutionAndWithUnresolvableLinks extends ChainOptions {
    withAllLocales: false;
    withoutLinkResolution: false;
    withoutUnresolvableLinks: false;
}
export interface ChainOptionWithLinkResolutionAndWithoutUnresolvableLinks extends ChainOptions {
    withAllLocales: false;
    withoutLinkResolution: false;
    withoutUnresolvableLinks: true;
}
export interface ChainOptionWithAllLocalesAndWithLinkResolutionAndWithUnresolvableLinks extends ChainOptions {
    withoutLinkResolution: false;
    withAllLocales: true;
    withoutUnresolvableLinks: false;
}
export interface ChainOptionWithAllLocalesAndWithoutLinkResolution extends ChainOptions {
    withoutLinkResolution: true;
    withAllLocales: true;
}
export interface ChainOptionWithLinkResolutionAndWithUnresolvableLinks extends ChainOptions {
    withoutLinkResolution: false;
    withAllLocales: false;
    withoutUnresolvableLinks: false;
}
export interface ChainOptionWithAllLocalesAndWithLinkResolutionAndWithoutUnresolvableLinks extends ChainOptions {
    withoutLinkResolution: false;
    withAllLocales: true;
    withoutUnresolvableLinks: true;
}
export type DefaultChainOption = ChainOptionWithLinkResolutionAndWithUnresolvableLinks;
export declare function isClientWithLinkResolutionAndWithUnresolvableLinks(options: ChainOptions): options is ChainOptionWithLinkResolutionAndWithUnresolvableLinks;
export declare function isClientWithLinkResolutionAndWithoutUnresolvableLinks(options: ChainOptions): options is ChainOptionWithLinkResolutionAndWithoutUnresolvableLinks;
export declare function isClientWithoutLinkResolution(options: ChainOptions): options is ChainOptionWithoutLinkResolution;
export declare function isClientWithAllLocalesAndWithLinkResolutionAndWithUnresolvableLinks(options: ChainOptions): options is ChainOptionWithAllLocalesAndWithLinkResolutionAndWithUnresolvableLinks;
export declare function isClientWithAllLocalesAndWithoutLinkResolution(options: ChainOptions): options is ChainOptionWithAllLocalesAndWithoutLinkResolution;
export declare function isClientWithAllLocalesAndWithLinkResolutionAndWithoutUnresolvableLinks(options: ChainOptions): options is ChainOptionWithAllLocalesAndWithLinkResolutionAndWithoutUnresolvableLinks;
